[arch-commits] Commit in cryptsetup/trunk (encrypt_hook)

Dave Reisner dreisner at archlinux.org
Sat Apr 21 17:40:42 UTC 2012


    Date: Saturday, April 21, 2012 @ 13:40:41
  Author: dreisner
Revision: 156607

Implement FS#27308

Modified:
  cryptsetup/trunk/encrypt_hook

--------------+
 encrypt_hook |  242 +++++++++++++++++++++++++++------------------------------
 1 file changed, 115 insertions(+), 127 deletions(-)

Modified: encrypt_hook
===================================================================
--- encrypt_hook	2012-04-21 17:30:40 UTC (rev 156606)
+++ encrypt_hook	2012-04-21 17:40:41 UTC (rev 156607)
@@ -1,148 +1,136 @@
 # vim: set ft=sh:
 # TODO this one needs some work to work with lots of different
 #       encryption schemes
-run_hook ()
-{
+run_hook() {
     /sbin/modprobe -a -q dm-crypt >/dev/null 2>&1
-    if [ -e "/sys/class/misc/device-mapper" ]; then
-        if [ ! -e "/dev/mapper/control" ]; then
-            mkdir /dev/mapper
-            mknod "/dev/mapper/control" c $(cat /sys/class/misc/device-mapper/dev | sed 's|:| |')
-        fi
-        [ "${quiet}" = "y" ] && CSQUIET=">/dev/null"
+    [ "${quiet}" = "y" ] && CSQUIET=">/dev/null"
 
-        # Get keyfile if specified
-        ckeyfile="/crypto_keyfile.bin"
-        if [ "x${cryptkey}" != "x" ]; then
-            ckdev="$(echo "${cryptkey}" | cut -d: -f1)"
-            ckarg1="$(echo "${cryptkey}" | cut -d: -f2)"
-            ckarg2="$(echo "${cryptkey}" | cut -d: -f3)"
-            if poll_device "${ckdev}" ${rootdelay}; then
-                case ${ckarg1} in
-                    *[!0-9]*)
-                        # Use a file on the device
-                        # ckarg1 is not numeric: ckarg1=filesystem, ckarg2=path
-                        mkdir /ckey
-                        mount -r -t ${ckarg1} ${ckdev} /ckey
-                        dd if=/ckey/${ckarg2} of=${ckeyfile} >/dev/null 2>&1
-                        umount /ckey
-                        ;;
-                    *)
-                        # Read raw data from the block device
-                        # ckarg1 is numeric: ckarg1=offset, ckarg2=length
-                        dd if=${ckdev} of=${ckeyfile} bs=1 skip=${ckarg1} count=${ckarg2} >/dev/null 2>&1
-                        ;;
-                esac
-            fi
-            [ ! -f ${ckeyfile} ] && echo "Keyfile could not be opened. Reverting to passphrase."
-        fi
-
-        if [ -n "${cryptdevice}" ]; then
-            DEPRECATED_CRYPT=0
-            cryptdev="$(echo "${cryptdevice}" | cut -d: -f1)"
-            cryptname="$(echo "${cryptdevice}" | cut -d: -f2)"
-            cryptoptions="$(echo "${cryptdevice}" | cut -d: -f3)"
-        else
-            DEPRECATED_CRYPT=1
-            cryptdev="${root}"
-            cryptname="root"
-        fi
-
-        warn_deprecated() {
-            echo "The syntax 'root=${root}' where '${root}' is an encrypted volume is deprecated"
-            echo "Use 'cryptdevice=${root}:root root=/dev/mapper/root' instead."
-        }
-
-        OLDIFS="${IFS}"
-        IFS=","
-        for cryptopt in ${cryptoptions}; do
-            case ${cryptopt} in
-                allow-discards)
-                    echo "Enabling TRIM/discard support."
-                    cryptargs="${cryptargs} --allow-discards"
+    # Get keyfile if specified
+    ckeyfile="/crypto_keyfile.bin"
+    if [ -n "$cryptkey" ]; then
+        IFS=: read ckdev ckarg1 ckarg2 <<EOF
+$cryptkey
+EOF
+        if poll_device "${ckdev}" ${rootdelay}; then
+            case ${ckarg1} in
+                *[!0-9]*)
+                    # Use a file on the device
+                    # ckarg1 is not numeric: ckarg1=filesystem, ckarg2=path
+                    mkdir /ckey
+                    mount -r -t "$ckarg1" "$ckdev" /ckey
+                    dd if="/ckey/$ckarg2" of="$ckeyfile" >/dev/null 2>&1
+                    umount /ckey
                     ;;
                 *)
-                    echo "Encryption option '${cryptopt}' not known, ignoring." >&2
+                    # Read raw data from the block device
+                    # ckarg1 is numeric: ckarg1=offset, ckarg2=length
+                    dd if="$ckdev" of="$ckeyfile" bs=1 skip="$ckarg1" count="$ckarg2" >/dev/null 2>&1
                     ;;
             esac
-        done
-        IFS="${OLDIFS}"
+        fi
+        [ ! -f ${ckeyfile} ] && echo "Keyfile could not be opened. Reverting to passphrase."
+    fi
 
-        if  poll_device "${cryptdev}" ${rootdelay}; then
-            if /sbin/cryptsetup isLuks ${cryptdev} >/dev/null 2>&1; then
-                [ ${DEPRECATED_CRYPT} -eq 1 ] && warn_deprecated
-                dopassphrase=1
-                # If keyfile exists, try to use that
-                if [ -f ${ckeyfile} ]; then
-                    if eval /sbin/cryptsetup --key-file ${ckeyfile} luksOpen ${cryptdev} ${cryptname} ${cryptargs} ${CSQUIET}; then
-                        dopassphrase=0
-                    else
-                        echo "Invalid keyfile. Reverting to passphrase."
-                    fi
-                fi
-                # Ask for a passphrase
-                if [ ${dopassphrase} -gt 0 ]; then
-                    echo ""
-                    echo "A password is required to access the ${cryptname} volume:"
+    if [ -n "${cryptdevice}" ]; then
+        DEPRECATED_CRYPT=0
+        IFS=: read cryptdev cryptname cryptoptions <<EOF
+$cryptdevice
+EOF
+    else
+        DEPRECATED_CRYPT=1
+        cryptdev="${root}"
+        cryptname="root"
+    fi
 
-                    #loop until we get a real password
-                    while ! eval /sbin/cryptsetup luksOpen ${cryptdev} ${cryptname} ${cryptargs} ${CSQUIET}; do
-                        sleep 2;
-                    done
-                fi
-                if [ -e "/dev/mapper/${cryptname}" ]; then
-                    if [ ${DEPRECATED_CRYPT} -eq 1 ]; then
-                        export root="/dev/mapper/root"
-                    fi
+    warn_deprecated() {
+        echo "The syntax 'root=${root}' where '${root}' is an encrypted volume is deprecated"
+        echo "Use 'cryptdevice=${root}:root root=/dev/mapper/root' instead."
+    }
+
+    for cryptopt in ${cryptoptions//,/ }; do
+        case ${cryptopt} in
+            allow-discards)
+                echo "Enabling TRIM/discard support."
+                cryptargs="${cryptargs} --allow-discards"
+                ;;
+            *)
+                echo "Encryption option '${cryptopt}' not known, ignoring." >&2
+                ;;
+        esac
+    done
+
+    if  poll_device "${cryptdev}" ${rootdelay}; then
+        if /sbin/cryptsetup isLuks ${cryptdev} >/dev/null 2>&1; then
+            [ ${DEPRECATED_CRYPT} -eq 1 ] && warn_deprecated
+            dopassphrase=1
+            # If keyfile exists, try to use that
+            if [ -f ${ckeyfile} ]; then
+                if eval /sbin/cryptsetup --key-file ${ckeyfile} luksOpen ${cryptdev} ${cryptname} ${cryptargs} ${CSQUIET}; then
+                    dopassphrase=0
                 else
-                    err "Password succeeded, but ${cryptname} creation failed, aborting..."
-                    exit 1
+                    echo "Invalid keyfile. Reverting to passphrase."
                 fi
-            elif [ -n "${crypto}" ]; then
-                [ ${DEPRECATED_CRYPT} -eq 1 ] && warn_deprecated
-                msg "Non-LUKS encrypted device found..."
-                if echo "$crypto" | awk -F: '{ exit(NF == 5) }'; then
-                    err "Verify parameter format: crypto=hash:cipher:keysize:offset:skip"
-                    err "Non-LUKS decryption not attempted..."
-                    return 1
+            fi
+            # Ask for a passphrase
+            if [ ${dopassphrase} -gt 0 ]; then
+                echo ""
+                echo "A password is required to access the ${cryptname} volume:"
+
+                #loop until we get a real password
+                while ! eval /sbin/cryptsetup luksOpen ${cryptdev} ${cryptname} ${cryptargs} ${CSQUIET}; do
+                    sleep 2;
+                done
+            fi
+            if [ -e "/dev/mapper/${cryptname}" ]; then
+                if [ ${DEPRECATED_CRYPT} -eq 1 ]; then
+                    export root="/dev/mapper/root"
                 fi
-                exe="/sbin/cryptsetup create ${cryptname} ${cryptdev} ${cryptargs}"
-                tmp=$(echo "${crypto}" | cut -d: -f1)
-                [ -n "${tmp}" ] && exe="${exe} --hash \"${tmp}\""
-                tmp=$(echo "${crypto}" | cut -d: -f2)
-                [ -n "${tmp}" ] && exe="${exe} --cipher \"${tmp}\""
-                tmp=$(echo "${crypto}" | cut -d: -f3)
-                [ -n "${tmp}" ] && exe="${exe} --key-size \"${tmp}\""
-                tmp=$(echo "${crypto}" | cut -d: -f4)
-                [ -n "${tmp}" ] && exe="${exe} --offset \"${tmp}\""
-                tmp=$(echo "${crypto}" | cut -d: -f5)
-                [ -n "${tmp}" ] && exe="${exe} --skip \"${tmp}\""
-                if [ -f ${ckeyfile} ]; then
-                    exe="${exe} --key-file ${ckeyfile}"
-                else
-                    exe="${exe} --verify-passphrase"
-                    echo ""
-                    echo "A password is required to access the ${cryptname} volume:"
-                fi
-                eval "${exe} ${CSQUIET}"
+            else
+                err "Password succeeded, but ${cryptname} creation failed, aborting..."
+                exit 1
+            fi
+        elif [ -n "${crypto}" ]; then
+            [ ${DEPRECATED_CRYPT} -eq 1 ] && warn_deprecated
+            msg "Non-LUKS encrypted device found..."
+            if echo "$crypto" | awk -F: '{ exit(NF == 5) }'; then
+                err "Verify parameter format: crypto=hash:cipher:keysize:offset:skip"
+                err "Non-LUKS decryption not attempted..."
+                return 1
+            fi
+            exe="/sbin/cryptsetup create $cryptname $cryptdev $cryptargs"
+            IFS=: read c_hash c_cipher c_keysize c_offset c_skip <<EOF
+$crypto
+EOF
+            [ -n "$c_hash" ]    && exe="$exe --hash '$c_hash'"
+            [ -n "$c_cipher" ]  && exe="$exe --cipher '$c_cipher'"
+            [ -n "$c_keysize" ] && exe="$exe --key-size '$c_keysize'"
+            [ -n "$c_offset" ]  && exe="$exe --offset '$c_offset'"
+            [ -n "$c_skip" ]    && exe="$exe --skip '$c_skip'"
+            if [ -f "$ckeyfile" ]; then
+                exe="$exe --key-file $ckeyfile"
+            else
+                exe="$exe --verify-passphrase"
+                echo ""
+                echo "A password is required to access the ${cryptname} volume:"
+            fi
+            eval "$exe $CSQUIET"
 
-                if [ $? -ne 0 ]; then
-                    err "Non-LUKS device decryption failed. verify format: "
-                    err "      crypto=hash:cipher:keysize:offset:skip"
-                    exit 1
+            if [ $? -ne 0 ]; then
+                err "Non-LUKS device decryption failed. verify format: "
+                err "      crypto=hash:cipher:keysize:offset:skip"
+                exit 1
+            fi
+            if [ -e "/dev/mapper/${cryptname}" ]; then
+                if [ ${DEPRECATED_CRYPT} -eq 1 ]; then
+                    export root="/dev/mapper/root"
                 fi
-                if [ -e "/dev/mapper/${cryptname}" ]; then
-                    if [ ${DEPRECATED_CRYPT} -eq 1 ]; then
-                        export root="/dev/mapper/root"
-                    fi
-                else
-                    err "Password succeeded, but ${cryptname} creation failed, aborting..."
-                    exit 1
-                fi
             else
-                err "Failed to open encryption mapping: The device ${cryptdev} is not a LUKS volume and the crypto= paramater was not specified."
+                err "Password succeeded, but ${cryptname} creation failed, aborting..."
+                exit 1
             fi
+        else
+            err "Failed to open encryption mapping: The device ${cryptdev} is not a LUKS volume and the crypto= paramater was not specified."
         fi
-        rm -f ${ckeyfile}
     fi
+    rm -f ${ckeyfile}
 }




More information about the arch-commits mailing list